config/routes.rb
Rails.application.routes.draw do
  resources :measurements

  resources :quantities, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :reparent }
  end

  resources :units, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :rebase }
  end

  namespace :default do
    resources :units, only: [:index, :destroy] do
      member { post :import, :export }
      #collection { post :import_all }
    end
  end

  devise_for :users, path: '', path_names: {registration: 'profile'},
    controllers: {registrations: :registrations}
  resources :users, only: [:index, :show, :update] do
    member { get :disguise }
    collection { get :revert }
  end

  unauthenticated do
    as :user do
      root to: redirect('/sign_in')
    end
  end
  root to: redirect('/units'), as: :user_root

  direct(:source_code) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me' }
  direct(:issue_tracker) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me/issues' }
end

app/models/unit.rb
class Unit < ApplicationRecord
  ATTRIBUTES = [:symbol, :description, :multiplier, :base_id]

  belongs_to :user, optional: true
  belongs_to :base, optional: true, class_name: "Unit"
  has_many :subunits, class_name: "Unit", inverse_of: :base, dependent: :restrict_with_error

  validate if: ->{ base.present? } do
    errors.add(:base, :user_mismatch) unless user_id == base.user_id
    errors.add(:base, :self_reference) if id == base_id
    errors.add(:base, :multilevel_nesting) if base.base_id?
  end
  validates :symbol, presence: true, uniqueness: {scope: :user_id},
    length: {maximum: type_for_attribute(:symbol).limit}
  validates :description, length: {maximum: type_for_attribute(:description).limit}
  validates :multiplier, numericality: {equal_to: 1}, unless: :base
  validates :multiplier, numericality: {greater_than: 0, precision: true, scale: true}, if: :base

  scope :defaults, ->{ where(user: nil) }
  scope :defaults_diff, ->{
    actionable_units = Arel::Table.new('actionable_units')
    units = actionable_units.alias('units')
    bases_units = arel_table.alias('bases_units')
    other_units = arel_table.alias('other_units')
    other_bases_units = arel_table.alias('other_bases_units')
    sub_units = arel_table.alias('sub_units')

    # TODO: move inner 'with' CTE to outer 'with recursive' - it can have multiple
    # CTEs, even non recursive ones.
    Unit.with_recursive(actionable_units: [
      Unit.with(units: self.or(Unit.defaults)).left_joins(:base)
        .where.not(
          # Exclude Units that are/have default counterpart
          Arel::SelectManager.new.project(1).from(other_units)
            .outer_join(other_bases_units)
            .on(other_units[:base_id].eq(other_bases_units[:id]))
            .where(
              other_bases_units[:symbol].is_not_distinct_from(bases_units[:symbol])
                .and(other_units[:symbol].eq(arel_table[:symbol]))
                .and(other_units[:user_id].is_distinct_from(arel_table[:user_id]))
            ).exists
        )
        .select(
          arel_table[Arel.star],
          # Decide if Unit can be im-/exported based on existing hierarchy:
          # * same base unit symbol has to exist
          # * unit with subunits can only be ported to root
          arel_table[:base_id].eq(nil).or(
            (
              Arel::SelectManager.new.project(1).from(other_units)
                .join(sub_units).on(other_units[:id].eq(sub_units[:base_id]))
                .where(
                  other_units[:symbol].eq(arel_table[:symbol])
                    .and(other_units[:user_id].is_distinct_from(arel_table[:user_id]))
                ).exists.not
            ).and(
              Arel::SelectManager.new.project(1).from(other_bases_units)
                .where(
                  other_bases_units[:symbol].is_not_distinct_from(bases_units[:symbol])
                    .and(other_bases_units[:user_id].is_distinct_from(bases_units[:user_id]))
                ).exists
            )
          ).as('portable')
        ),
      # Fill base Units to display proper hierarchy. Duplicates will be removed
      # by final group() - can't be deduplicated with UNION due to 'portable' field.
      arel_table.join(actionable_units).on(actionable_units[:base_id].eq(arel_table[:id]))
        .project(arel_table[Arel.star], Arel::Nodes.build_quoted(nil).as('portable'))
    ]).select(units: [:base_id, :symbol])
      .select(
        units[:id].minimum.as('id'), # can be ANY_VALUE()
        units[:user_id].minimum.as('user_id'), # prefer non-default
        Arel::Nodes.build_quoted(1).as('multiplier'), # disregard multiplier when sorting
        units[:portable].minimum.as('portable')
      )
      .from(units).group(:base_id, :symbol)
  }
  scope :ordered, ->{
    left_outer_joins(:base).order(ordering)
  }

  def self.ordering
    [arel_table.coalesce(Arel::Table.new(:bases_units)[:symbol], arel_table[:symbol]),
     arel_table[:base_id].not_eq(nil),
     :multiplier,
     :symbol]
  end

  before_destroy do
    # TODO: disallow destruction if any object depends on this unit
    nil
  end

  def to_s
    symbol
  end

  def movable?
    subunits.empty?
  end

  def default?
    user_id.nil?
  end

  # Should only by invoked on Units returned from #defaults_diff which are #portable
  def port!(recipient)
    recipient_base = base && Unit.find_by!(symbol: base.symbol, user: recipient)
    params = slice(ATTRIBUTES - [:symbol, :base_id])
    Unit.find_or_initialize_by(user: recipient, symbol: symbol)
      .update!(base: recipient_base, **params)
  end

  def successive
    units = Unit.arel_table
    lead = Arel::Nodes::NamedFunction.new('LAG', [units[:id]])
    window = Arel::Nodes::Window.new.order(*Unit.ordering)
    lag_id = lead.over(window).as('lag_id')
    Unit.with(
      units: user.units.left_outer_joins(:base).select(units[Arel.star], lag_id)
    ).where(units[:lag_id].eq(id)).first
  end
end

app/controllers/default/units_controller.rb
class Default::UnitsController < ApplicationController
  navigation_tab :units

  before_action :find_unit, only: :export
  before_action :find_unit_default, only: [:import, :destroy]

  before_action only: :import do
    raise AccessForbidden unless current_user.at_least(:active)
  end
  before_action except: [:index, :import] do
    raise AccessForbidden unless current_user.at_least(:admin)
  end

  def index
    @units = current_user.units.defaults_diff.includes(:base).includes(:subunits).ordered
  end

  def import
    @unit.port!(current_user)
    flash.now[:notice] = t('.success', unit: @unit)
  ensure
    run_and_render :index
  end

  #def import_all
    # From defaults_diff return not only portability, but reason for not being
    # portable: missing_base and nesting_too_deep. Add portable and
    # missing_base, if possible in one query
  #end

  def export
    @unit.port!(nil)
    flash.now[:notice] = t('.success', unit: @unit)
  ensure
    run_and_render :index
  end

  def destroy
    @unit.destroy!
    flash.now[:notice] = t('.success', unit: @unit)
  ensure
    run_and_render :index
  end

  private

  def find_unit
    @unit = current_user.units.find_by!(id: params[:id])
  end

  def find_unit_default
    @unit = Unit.find_by!(id: params[:id], user: nil)
  end
end

app/controllers/units_controller.rb
class UnitsController < ApplicationController
  before_action only: :new do
    find_unit if params[:id].present?
  end
  before_action :find_unit, only: [:edit, :update, :rebase, :destroy]

  before_action except: :index do
    raise AccessForbidden unless current_user.at_least(:active)
  end

  def index
    @units = current_user.units.ordered.includes(:base).includes(:subunits)
  end

  def new
    @unit = current_user.units.new(base: @unit)
  end

  def create
    @unit = current_user.units.new(unit_params)
    if @unit.save
      @before = @unit.successive
      flash.now[:notice] = t('.success', unit: @unit)
    else
      render :new
    end
  end

  def edit
  end

  def update
    if @unit.update(unit_params.except(:base_id))
      flash.now[:notice] = t('.success', unit: @unit)
    else
      render :edit
    end
  end

  # TODO: Avoid double table width change by first un-hiding table header,
  # then displaying index, e.g. by re-displaying header in index
  def rebase
    permitted = params.require(:unit).permit(:base_id)
    permitted.merge!(multiplier: 1) if permitted[:base_id].blank? && @unit.multiplier != 1

    @previous_base = @unit.base
    @unit.update!(permitted)

    @before = @unit.successive
    if @unit.multiplier_previously_changed?
      flash.now[:notice] = t(".multiplier_reset", unit: @unit)
    end
  end

  def destroy
    @unit.destroy!
    flash.now[:notice] = t('.success', unit: @unit)
  end

  private

  def unit_params
    params.require(:unit).permit(Unit::ATTRIBUTES)
  end

  def find_unit
    @unit = current_user.units.find_by!(id: params[:id])
  end
end

app/helpers/default/units_helper.rb
module Default::UnitsHelper
end

app/helpers/units_helper.rb
module UnitsHelper
end

app/views/units/_form.html.erb
<%= tabular_fields_for @unit, form: form_tag do |form| %>
  <%- tag.tr id: row, class: "form", onkeydown: "processKey(event)",
    data: {link: link, form: form_tag, hidden_row: hidden_row} do %>

    <td style="--depth:<%= @unit.base_id? ? 1 : 0 %>">
      <%= form.text_field :symbol, required: true, autofocus: true, size: 12 %>
    </td>
    <td>
      <%= form.text_area :description, cols: 30, rows: 1, escape: false %>
    </td>
    <td class="number">
      <%= form.number_field :multiplier, required: true, size: 10, min: :step if @unit.base_id? %>
    </td>

    <td class="actions">
      <%= form.button %>
      <%= image_link_to t(:cancel), "close-outline", units_path, class: 'dangerous',
        name: :cancel, onclick: render_turbo_stream('form_close', {row: row}) %>
    </td>
    <td></td>
  <% end %>
<% end %>

app/views/units/_form_close.html.erb
<%= turbo_stream.close_form row %>
<%= turbo_stream.update :flashes %>

app/views/units/_unit.html.erb
<%= tag.tr id: dom_id(unit),
           ondragstart: "dragStart(event)", ondragend: "dragEnd(event)",
           ondragover: "dragOver(event)", ondrop: "drop(event)",
           ondragenter: "dragEnter(event)", ondragleave: "dragLeave(event)",
           data: {drag_path: rebase_unit_path(unit),
                  drop_id: dom_id(unit.base || unit),
                  drop_id_param: "unit[base_id]"} do %>

  <td class="link" style="--depth:<%= unit.base_id? ? 1 : 0 %>">
    <%= link_to unit, edit_unit_path(unit), onclick: 'this.blur();', data: {turbo_stream: true} %>
  </td>
  <td><%= unit.description %></td>
  <td class="number"><%= unit.multiplier.to_html %></td>

  <% if current_user.at_least(:active) %>
    <td class="actions">
      <% unless unit.base_id? %>
        <%= image_link_to t('.new_subunit'), 'plus-outline', new_unit_path(unit),
          id: dom_id(unit, :new, :link), onclick: 'this.blur();', data: {turbo_stream: true} %>
      <% end %>

      <%= image_button_to_if unit.movable?, t('.destroy'), 'delete-outline', unit_path(unit),
        method: :delete %>
    </td>
    <% if unit.movable? %>
      <td class="handle" draggable="true">&#x283F</td>
    <% else %>
      <td></td>
    <% end %>
  <% end %>
<% end %>

app/views/units/create.turbo_stream.erb
<%= turbo_stream.close_form dom_id(@unit.base || Unit, :new) %>
<%= turbo_stream.remove :no_items %>
<%= turbo_stream.replace @unit.base if @unit.base_id? %>
<%= @before ? turbo_stream.before(@before, @unit) : turbo_stream.append(:units, @unit) %>

app/views/units/destroy.turbo_stream.erb
<%= turbo_stream.replace @unit.base if @unit.base_id? %>
<%= turbo_stream.remove @unit %>
<%= turbo_stream.append(:units, render_no_items) if current_user.units.empty? %>

app/views/units/edit.turbo_stream.erb
<% ids = {row: dom_id(@unit, :edit),
          hidden_row: dom_id(@unit),
          link: nil,
          form_tag: dom_id(@unit, :edit, :form)} %>

<%= turbo_stream.append :unit_form do %>
  <%- tabular_form_with model: @unit, html: {id: ids[:form_tag]} do %>
  <% end %>
<% end %>

<%= turbo_stream.hide ids[:hidden_row] %>
<%= turbo_stream.remove ids[:row] %>
<%= turbo_stream.after @unit, partial: 'form', locals: ids -%>

app/views/units/index.html.erb
<div class="rightside buttongrid">
  <% if current_user.at_least(:active) %>
    <%= image_link_to t('.new_unit'), 'plus-outline', new_unit_path,
      id: dom_id(Unit, :new, :link), onclick: 'this.blur();', data: {turbo_stream: true} %>
  <% end %>
  <%= image_link_to t('.import_units'), 'download-outline', default_units_path, class: 'tools' %>
</div>

<%= tag.div id: :unit_form %>

<table class="main items">
  <thead>
    <tr>
      <th><%= User.human_attribute_name(:symbol).capitalize %></th>
      <th><%= User.human_attribute_name(:description).capitalize %></th>
      <th><%= User.human_attribute_name(:multiplier).capitalize %></th>
      <% if current_user.at_least(:active) %>
        <th><%= t :actions %></th>
        <th></th>
      <% end %>
    </tr>
    <%= tag.tr id: "unit_", hidden: true,
               ondragover: "dragOver(event)", ondrop: "drop(event)",
               ondragenter: "dragEnter(event)", ondragleave: "dragLeave(event)",
               data: {drop_id: "unit_", drop_id_param: "unit[base_id]"} do %>
      <th colspan="5"><%= t '.top_level_drop' %></th>
    <% end %>
  </thead>
  <tbody id="units">
    <%= render(@units) || render_no_items %>
  </tbody>
</table>

app/views/units/new.turbo_stream.erb
<% dom_obj = @unit.base || @unit %>
<% ids = {row: dom_id(dom_obj, :new),
          hidden_row: nil,
          link: dom_id(dom_obj, :new, :link),
          form_tag: dom_id(dom_obj, :new, :form)} %>

<%= turbo_stream.disable ids[:link] -%>

<%= turbo_stream.append :unit_form do %>
  <%- tabular_form_with model: @unit, html: {id: ids[:form_tag]} do |form| %>
    <%= form.hidden_field :base_id if @unit.base_id? %>
  <% end %>
<% end %>

<% if @unit.base_id? %>
  <%= turbo_stream.remove ids[:row] %>
  <%= turbo_stream.after @unit.base, partial: 'form', locals: ids %>
<% else %>
  <%= turbo_stream.prepend :units, partial: 'form', locals: ids %>
<% end %>

app/views/units/rebase.turbo_stream.erb
<%= turbo_stream.remove @unit %>
<%= turbo_stream.replace @previous_base if @previous_base %>
<%= turbo_stream.replace @unit.base if @unit.base_id? && (@previous_base.id != @unit.base_id) %>
<%= @before ? turbo_stream.before(@before, @unit) : turbo_stream.append(:units, @unit) %>

app/views/units/update.turbo_stream.erb
<%= turbo_stream.close_form dom_id(@unit, :edit) %>
<%= turbo_stream.replace @unit.base if @unit.base_id? %>
<%= turbo_stream.replace @unit %>